<!--
<new-program
  :editRow="editRow"
  :showDialog="showDialog"
  @hideDialog="hideDialog">
</new-program>

import newProgram from '@/components/program/new-program.vue'
 -->
<template>
  <div v-show="customDialog">
    <el-dialog class="edit-dialog" :title="formData.projectId ? '编辑项目' : '新建项目'" :visible.sync="customDialog" width="600px" :before-close="handleClose">
      <div class="edit-dialog-body">
        <el-form :model="formData" label-width="94px" :rules="rules" ref="programForm">
          <el-form-item label="项目名称:" prop="projectName">
            <limitInput :inputWidth="440" :inputValue.sync="formData.projectName" :holder="'请输入项目名称'" :getByType="'word'" :maxLength="20"> </limitInput>
          </el-form-item>
          <el-form-item label="描述:">
            <limit-textarea :inputWidth="440" :inputValue.sync="formData.projectDescribe" :holder="'请输入描述内容'" :getByType="'word'" :maxLength="100"> </limit-textarea>
          </el-form-item>
        </el-form>
      </div>
      <div slot="footer" class="dialog-footer" style="padding-bottom: 10px;">
        <el-button @click="customCancel">取 消</el-button>
        <el-button type="primary" @click="customConfirm('programForm')">{{ formData.projectId ? '保 存' : '新 建' }}</el-button>
      </div>
    </el-dialog>
  </div>
</template>
<script>
import limitInput from '@/components/limit-input.vue';
import limitTextarea from '@/components/limit-textarea.vue';
import { getRequest } from '@/api/api';
import showMsg from '@/assets/js/showmsg';
import errMsg from '@/assets/js/error';
export default {
  name: 'new-env',
  props: {
    showDialog: {
      type: Boolean,
      default: false
    },
    editRow: {
      type: Object,
      default() {
        return {
          projectId: '',
          projectName: '',
          projectDescribe: ''
        };
      }
    }
  },
  components: {
    limitInput,
    limitTextarea
  },
  data() {
    return {
      customDialog: false, // 弹框显示
      formData: {
        projectId: '',
        projectName: '',
        projectDescribe: ''
      },
      rules: {
        projectName: [{ required: true, message: '请输入项目名称', trigger: 'blur' }],
        projectDescribe: [{ required: true, message: '请输入描述', trigger: 'blur' }]
      }
    };
  },
  methods: {
    /**
     *   关闭
     */
    handleClose(done) {
      const that = this;
      that.$refs['programForm'].resetFields();
      done();
      that.hideDialog();
    },

    /**
     *  取消
     */
    customCancel() {
      const that = this;
      that.$refs['programForm'].resetFields();
      that.hideDialog();
    },

    hideDialog() {
      const that = this;
      that.customDialog = false;
      that.formData.projectName = '';
      that.formData.projectDescribe = '';
      that.$emit('hideDialog', '');
      /* that.$nextTick(() => {
        that.formData.classifyName = '';
      }); */
    },

    /**
     *  确定
     */
    customConfirm(formName) {
      const that = this;
      that.formData.projectName = that.formData.projectName ? String(that.formData.projectName).replace(/\s+/g, '') : '';
      that.formData.projectDescribe = that.formData.projectDescribe ? String(that.formData.projectDescribe).replace(/\s+/g, '') : '';
      that.$refs[formName].validate(valid => {
        if (valid) {
          that.postEditData();
        } else {
          return false;
        }
      });
    },
    postEditData() {
      const that = this;
      let para = {
        projectId: that.formData.projectId,
        projectName: that.formData.projectName,
        projectDescribe: that.formData.projectDescribe
      };
      getRequest(that.editRow.projectId ? '/gateway-manage/update-project' : '/gateway-manage/create-project', para)
        .then(res => {
          let resData = res.data;
          if (resData.code == '0000') {
            showMsg.showmsg('保存成功', 'success');
            that.setData();
            return;
          }
          errMsg.errorMsg(resData);
        })
        .catch(function(error) {
          that.$message.error({
            duration: 1000,
            message: error.message
          });
        });
    },

    /**
     *  提交数据
     */
    setData(list) {
      const that = this;
      that.$emit('hideDialog', that.formData);
      that.$nextTick(() => {
        that.formData.projectName = '';
        that.formData.projectDescribe = '';
      });
    }
  },
  watch: {
    showDialog: function(newData, oldData) {
      const that = this;
      that.customDialog = newData;
    },
    editRow: function(newData, oldData) {
      const that = this;
      if (Object.keys(newData).length) {
        that.formData = JSON.parse(JSON.stringify(newData));
      }
    }
  },

  /* 接收数据 */
  mounted() {
    const that = this;
    that.customDialog = that.showDialog;
    if (Object.keys(that.editRow).length) {
      that.formData = JSON.parse(JSON.stringify(that.editRow));
    }
  }
};
</script>

<style lang="less" scoped>
.edit-dialog {
  /deep/ .el-dialog__body {
    padding: 2px 55px 0 34px;
  }

  /deep/ .el-dialog__footer {
    border: none;
    padding-top: 3px;
  }

  &__title {
    width: 100%;
    height: 38px;
    padding: 12px 15px;
    -webkit-box-sizing: border-box;
    -moz-box-sizing: border-box;
    box-sizing: border-box;
    background: rgba(235, 238, 245, 1);
  }

  .el-alert--info {
    width: 400px;
    font-size: 14px;
    color: #606266;
    background: #e6f7ff;
    border: 1px solid rgba(145, 213, 255, 1);
  }
  .el-icon-info {
    width: 12px;
    font-size: 12px;
    color: #1890ff;
  }
  .el-form {
    margin-top: 40px;
  }
}
</style>
